# CheapWireCut release 4 by David Bowland
# ./addons/eventscripts/cheapwirecut/cheapwirecut.py

# >>> To configure this addon please see cheapwirecut.cfg (created whent he addon is first loaded) <<<

"""
Allows player to instantly defuse the bomb at the risk of detonation. Requires only ES 2.0+
"""


import cfglib
import es
import gamethread
import langlib
import os.path
import playerlib
import random

import psyco
psyco.full()


info = es.AddonInfo()
info.name     = 'CheapWireCut'
info.version  = '4'
info.basename = 'cheapwirecut'
info.url      = 'http://addons.eventscripts.com/addons/view/' + info.basename
info.author   = 'SuperDave'


###


config = cfglib.AddonCFG(es.getAddonPath(info.basename) + '/' + info.basename + '.cfg')

config.text(info.name + ' release %s options' % info.version)
config.text('./addons/eventscripts/%(basename)s/%(basename)s.cfg' % {'basename':info.basename})
config.text(info.url)
config.text('')
config.text('Load this addon with: es_load ' + info.basename)
config.text('\n')
config.text('To configure language settings for %s please see %s_languages.ini' % (info.name, info.basename))
config.text('\n')
config.text('Thanks to 7355608 for this script idea. CutWires can be found here:')
config.text('http://addons.eventscripts.com/addons/view/cutwires')
config.text('')
config.text('Thanks also to *X*Y*Z*SaYnt. HailMary can be found here:')
config.text('http://addons.eventscripts.com/addons/view/hailmary')
config.text('\n')
config.text('This addon is compatible with CheapBombTimer, which can be found here:')
config.text('http://addons.eventscripts.com/addons/view/cheapbombtimer')
config.text('\n')

config.text('***** General options *****')
cvar_pull = config.cvar('cheapwirecut_pull', 65, 'Percent chance pulling a wire detonates the bomb')
cvar_cut  = config.cvar('cheapwirecut_cut',  28, 'Percent chance cutting a wire (defuse kit only) detonates the bomb')
config.text('\n')

config.text('***** BPS option *****')
cvar_bps = config.cvar('cheapwirecut_bps', 83, 'Bomb beeps per second (x 10)')
config.text('To test your cheapwirecut_bps setting load CheapWireCut, plant the bomb and let it explode.')
config.text('If your cheapwirecut_bps setting is incorrect you will be told the correct value when the bomb explodes.')
config.text('\n')

config.text('***** Minigame options *****')
cvar_minigame        = config.cvar('cheapwirecut_minigame',        1,            '0 = no change, 1 = players planting the bomb will be prompted to select menu items to increase detonation chance')
cvar_minigame_digits = config.cvar('cheapwirecut_minigame_digits', '0123456789', 'Digits possible in the minigame--only 1 through 9 will increase explosion chance, 0 will omit the selection')
cvar_minigame_pull   = config.cvar('cheapwirecut_minigame_pull',   6,            'Percentage points added to the detonation chance of pulling a wire by pressing the correct digit in the minigame')
cvar_minigame_cut    = config.cvar('cheapwirecut_minigame_cut',   12,            'Percentage points added to the detonation chance of cutting a wire by pressing the correct digit in the minigame')
config.text('\n')

config.text('***** Bot options *****')
cvar_bot_defuse_percent   = config.cvar('cheapwirecut_bot_defuse_percent',   85, 'Maximum chance of explosion allowed for a bot to pull or cut a wire--set to 0 to eliminate')
cvar_bot_defuse_perceived = config.cvar('cheapwirecut_bot_defuse_perceived', 50, 'Maximum perceived chance of explosion for a bot to pull or cut a wire--set to 0 to eliminate')
cvar_bot_defuse_hurt      = config.cvar('cheapwirecut_bot_defuse_hurt',      80, 'Percent chance a bot will pull or cut a wire if attacked while defusing--set to 0 to eliminate')
cvar_bot_defuse_threshold = config.cvar('cheapwirecut_bot_defuse_threshold', 2,  'Bomb time in seconds below which bots will prefer to pull or cut a wire rather than be defusing')
cvar_bot_minigame_chance  = config.cvar('cheapwirecut_bot_minigame_chance',  70, 'Percent chance a bot will increase the chance of detonation with the minigame')
cvar_bot_minigame_max     = config.cvar('cheapwirecut_bot_minigame_max',     5,  'Maximum number of times a bot can increase the chance of detonation with the minigame--set to 0 to eliminate')
config.text('\n')

config.text('***** Announcement options *****')
cvar_announce_percent_chat   = config.cvar('cheapwirecut_announce_percent_chat',   2, '0 = no change, 1 = announce the percent chance of detonation from pulling or cutting wire on the console to Terrorists, 2 = announce the percent chance of detonation from pulling or cutting wire in chat area to Terrorists, 3 = announce the percent chance of detonation from pulling or cutting wire on the console to all players, 4 = announce the percent chance of detonation from pulling or cutting wire in chat area to all players')
cvar_announce_percent_center = config.cvar('cheapwirecut_announce_percent_center', 0, '0 = no change, 1 = announce the percent chance of detonation from pulling or cutting wire in center text to Terrorists, 2 = announce the percent chance of detonation from pulling or cutting wire in center text to all players')
cvar_announce_percent_hud    = config.cvar('cheapwirecut_announce_percent_hud',    1, '0 = no change, 1 = announce the percent chance of detonation from pulling or cutting wire in a HUD message to Terrorists, 2 = announce the percent chance of detonation from pulling or cutting wire in a HUD message to all players')
cvar_announce_result_chat    = config.cvar('cheapwirecut_announce_result_chat',    4, '0 = no change, 1 = announce when a wire is cut or pulled on the console, 2 = announce when a wire is cut or pulled in chat area, 3 = announce when the bomb is defused normally and when a wire is cut or pulled on the console, 4 = announce when the bomb is defused normally and when a wire is cut or pulled in chat area')
cvar_announce_result_center  = config.cvar('cheapwirecut_announce_result_center',  0, '0 = no change, 1 = announce when a wire is cut or pulled in center text, 2 = announce when the bomb is defused normally and when a wire is cut or pulled in center text')
cvar_announce_result_hud     = config.cvar('cheapwirecut_announce_result_hud',     2, '0 = no change, 1 = announce when a wire is cut or pulled in a HUD message, 2 = announce when the bomb is defused normally and when a wire is cut or pulled in a HUD message')
config.text('\n')

config.text('***** Event documentation *****')
config.text('')
config.text('The following events will fire when CheapWireCut is loaded:')
config.text('')
config.text('bomb_wire')
config.text('- Fires when a player pulls or cuts a wire on the bomb BEFORE bomb_defused or bomb_exploded')
config.text('   event_var(userid)          - Userid of the player who pulled or cut a wire')
config.text('   event_var(action)          - Action performed ("PULL", "CUT")')
config.text('   event_var(result)          - Result of pulling or cutting the wire ("DEFUSED", "EXPLODED")')
config.text('')
config.text('cheapwirecut_minigame')
config.text('   event_var(userid)          - Userid of the player in the minigame')
config.text('   event_var(action)          - Action performed ("ADD_TO_CUT", "ADD_TO_PULL", "RESET", "FINISH", "CANCEL")')
config.text('   event_var(pull)            - Percent chance a pulled wire will explode')
config.text('   event_var(cut)             - Percent chance a cut wire will explode')
config.text('')
config.text('These events also provide event_var(es_steamid), event_var(es_username), and all the other event_vars that accompany')
config.text('event_var(userid). More information can be found here: http://www.eventscripts.com/pages/Extended_event_variables')

config.write()


###


class CheapWireCutManager(object):
   bps        = 1.
   start_time = 0
   mp_c4timer = es.ServerVar('mp_c4timer')

   def __init__(self):
      self.mg_choices = {}
      self.hurt_bots  = set()

      self.resetTicks()

   def closeMenu(self, userid):
      popup.unsend(userid)

   """ Bomb functions """

   def resetTicks(self):
      self.ticks    = -1
      self.minigame = 0

      self.mg_choices.clear()
      self.hurt_bots.clear()

      self.resetWires()

   def resetWires(self):
      self.wires = {'pull':int(cvar_pull), 'cut':int(cvar_cut)}

   def bombAbortPlant(self):
      if self.minigame:
         self.closeMenu(self.minigame)

         self._miniGameEvent(self.minigame, 'CANCEL')
         self.minigame = 0

   def bombPlanted(self):
      if self.minigame:
         self.closeMenu(self.minigame)

         self._miniGameEvent(self.minigame, 'FINISH')

      self.bps        = cvar_bps / 10.
      self.ticks      = 0
      self.start_time = int(self.mp_c4timer)
      self.minigame   = 0

      chat   = int(cvar_announce_percent_chat)
      center = int(cvar_announce_percent_center)
      hud    = int(cvar_announce_percent_hud)

      if chat or center or hud:
         for userid in es.getUseridList():
            player_lang = playerlib.getPlayer(userid).get('lang')
            isterrorist = es.getplayerteam(userid) <> 3

            if chat == 3 or (chat == 1 and isterrorist):
               es.cexec(userid, 'echo ' + self.__removeTags(lang_text('percent text', self.wires, player_lang)))
            elif chat == 4 or (chat and isterrorist):
               es.tell(userid, '#multi', lang_text('percent text', self.wires, player_lang))
            if center == 2 or (center and isterrorist):
               es.centertell(userid, self.__removeTags(lang_text('percent text', self.wires, player_lang)))
            if hud == 2 or (hud and isterrorist):
               line1 = lang_text('minigame pull header', self.wires, player_lang)
               line2 = lang_text('minigame cut header', self.wires, player_lang)
               self._hudHint(userid, line1.center(len(line2)) + '\n' + line2.center(len(line1)))

   def bombBeginDefuse(self, userid):
      has_defuser = es.getplayerprop(userid, 'CCSPlayer.m_bHasDefuser') % 2

      if es.getplayersteamid(userid) == 'BOT':
         selection, action = (3, 'pull') if self.wires['pull'] >= self.wires['cut'] and has_defuser else (1, 'cut')

         if self._getBombTime() - (5 if has_defuser else 10) < int(cvar_bot_defuse_threshold):
            self.wireAction(userid, selection)

         else:
            t_count         = es.getlivingplayercount(2)
            perceived_value = min(max(float(self.wires[action]) * es.getlivingplayercount(3) / t_count , 0), 100) if t_count else 100

            if perceived_value <= int(cvar_bot_defuse_perceived) and self.wires[action] <= int(cvar_bot_defuse_percent):
               self.wireAction(userid, selection)

      else:
         player_lang = playerlib.getPlayer(userid).get('lang')
         if has_defuser:
            popup.send(userid, 0, '%s\n \n->1. %s\n%s\n \n->3. %s\n%s\n \n0. %s' % (lang_text('pull cut header', {}, player_lang), lang_text('pull option', {}, player_lang), lang_text('pull cut chance', {'percent':self.wires['pull']}, player_lang), lang_text('cut option', {}, player_lang), lang_text('pull cut chance', {'percent':self.wires['cut']}, player_lang), lang_text('cancel', {}, player_lang)), self.wireAction)

         else:
            popup.send(userid, 0, '%s\n \n->1. %s\n%s\n \n0. %s' % (lang_text('pull header', {}, player_lang), lang_text('pull option', {}, player_lang), lang_text('pull cut chance', {'percent':self.wires['pull']}, player_lang), lang_text('cancel', {}, player_lang)), self.wireAction)

   def bombDefused(self, userid):
      if self.ticks == -1: return

      if int(cvar_announce_result_chat) in (3, 4) or cvar_announce_result_center == 2 or cvar_announce_result_hud == 2:
         self._announceResult('normal', 'defused', userid)
      self.resetTicks()

   def bombExploded(self):
      if self.ticks == -1: return

      self.ticks += 1
      bps = int(round(float(self.ticks + 1) / self.start_time * 10))
      if bps <> self.bps * 10.:
         es.centermsg('cheapwirecut_bps incorrectly configured!')
         es.msg('cheapwirecut_bps incorrectly configured!')
         es.msg('You should change your cheapwirecut_bps value to %s' % bps)
         es.msg('This setting can found in your cheapwirecut.cfg')

         cvar_bps.set(bps)

   def tick(self):
      if self.ticks == -1: return

      self.ticks += 1

   def playerHurt(self, userid):
      if es.getplayersteamid(userid) <> 'BOT' or self.ticks == -1: return

      if userid in self.hurt_bots or not es.getplayerprop(userid, 'CCSPlayer.m_bIsDefusing') % 2: return

      self.hurt_bots.add(userid)
      if random.randint(1, 100) > cvar_bot_defuse_hurt: return

      percent = int(cvar_bot_defuse_percent)
      if es.getplayerprop(userid, 'CCSPlayer.m_bHasDefuser') % 2 and self.wires['pull'] >= self.wires['cut']:
         if percent >= self.wires['cut']:
            self.wireAction(userid, 3)

      elif percent >= self.wires['pull']:
         self.wireAction(userid, 1)

   def wireAction(self, userid, item):
      if (item not in (1, 3)) if es.getplayerprop(userid, 'CCSPlayer.m_bHasDefuser') % 2 else (item <> 1): return True

      c4_index = es.getentityindex('planted_c4')
      if c4_index == -1:
         es.dbgmsg(0, 'CheapWireCut: Could not find C4!')
         return

      action = 'pull' if item == 1 else 'cut'
      if random.randint(1, 100) <= self.wires[action]:
         if es.exists('variable', 'cheapbombtimer_bps_skipcheck'):
            es.ServerVar('cheapbombtimer_bps_skipcheck').set(1)

         es.setindexprop(c4_index, 'CPlantedC4.m_flC4Blow', 1)
         result = 'exploded'

      else:
         es.setindexprop(c4_index, 'CPlantedC4.m_flDefuseCountDown', 1)
         result = 'defused'

      es.event('initialize', 'bomb_wire')
      es.event('setint',     'bomb_wire', 'userid', userid)
      es.event('setstring',  'bomb_wire', 'action', action.upper())
      es.event('setstring',  'bomb_wire', 'result', result.upper())
      es.event('fire',       'bomb_wire')

      es.setplayerprop(userid, 'CCSPlayer.m_iProgressBarDuration', 0)
      self._announceResult(action, result, userid)
      self.resetTicks()

      return False

   """ Minigame functions """

   def miniGame(self, userid):
      if not int(cvar_minigame): return

      self.resetWires()

      if es.getplayersteamid(userid) == 'BOT':
         bot_chance    = int(cvar_bot_minigame_chance)
         wire_addition = {'pull':int(cvar_minigame_pull), 'cut':int(cvar_minigame_cut)}

         for x in xrange(cvar_bot_minigame_max):
            if random.randint(1, 100) <= bot_chance:
               action = random.choice(('pull', 'cut'))

               self.wires[action] = min(wire_addition[action] + self.wires[action], 100)

               self._miniGameEvent(userid, 'ADD_TO_' + action.upper())

            else:
               self.resetWires()
               self._miniGameEvent(userid, 'RESET')
               return

         self._miniGameEvent(userid, 'FINISH')

      else:
         self.minigame = userid
         self._miniGameMenu(userid)

   def _miniGameMenu(self, userid, lastoption=None):
      choices = map(int, str(cvar_minigame_digits))
      if lastoption in choices:
         choices.remove(lastoption)

      if len(choices) > 1:
         self.mg_choices.clear()

         current_choice = random.choice(choices)
         self.mg_choices[current_choice] = 'pull'

         choices.remove(current_choice)
         current_choice = random.choice(choices)
         self.mg_choices[current_choice] = 'cut'

         player_lang = playerlib.getPlayer(userid).get('lang')
         menu_text   = '%s\n%s\n \n' % (lang_text('minigame pull header', self.wires, player_lang), lang_text('minigame cut header', self.wires, player_lang))

         for current_choice in sorted(self.mg_choices):
            if current_choice == 0: continue

            action = self.mg_choices[current_choice]
            if self.wires[action] < 100:
               menu_text += '->%s. %s\n \n' % (current_choice, lang_text('minigame %s option' % action, {'increase':str(es.ServerVar('cheapwirecut_minigame_%s' % action))}, player_lang))

         popup.send(userid, 0, menu_text + '0. ' + lang_text('cancel', {}, player_lang), self._miniGameChoice)

      else:
         es.dbgmsg(0, 'CheapWireCut: Insufficient number of digits in cheapwirecut_minigame_digits')
         popup.removePlayer(userid)
         self.minigame = 0

   def _miniGameChoice(self, userid, item):
      if item in self.mg_choices:
         action = self.mg_choices[item]

         self.wires[action] = min(es.ServerVar('cheapwirecut_minigame_' + action) + self.wires[action], 100)

         self._miniGameEvent(userid, 'ADD_TO_' + action.upper())

         self._miniGameMenu(userid, item)

      elif item == 10:
         self._miniGameEvent(userid, 'CANCEL')
         self.minigame = 0

      else:
         self.resetWires()

         self._miniGameEvent(userid, 'RESET')
         self.minigame = 0

      return False

   def _miniGameEvent(self, userid, action):
      es.event('initialize', 'cheapwirecut_minigame')
      es.event('setint',     'cheapwirecut_minigame', 'userid', userid)
      es.event('setstring',  'cheapwirecut_minigame', 'action', action)
      es.event('setint',     'cheapwirecut_minigame', 'pull',   self.wires['pull'])
      es.event('setint',     'cheapwirecut_minigame', 'cut',    self.wires['cut'])
      es.event('fire',       'cheapwirecut_minigame')

   """ Internal Functions """

   def _announceResult(self, action, result, userid):
      chat   = int(cvar_announce_result_chat)
      center = int(cvar_announce_result_center)
      hud    = int(cvar_announce_result_hud)

      if chat or center or hud:
         remaining_time = int(self._getBombTime())
         tokens         = {'seconds':remaining_time, 'player':es.getplayername(userid)}

         p1 = '%s %s p1' % (result, action)
         p2 = 'defused exploded singular p2' if remaining_time == 1 else 'defused exploded plural p2'

         for loop_userid in es.getUseridList():
            player_lang = playerlib.getPlayer(loop_userid).get('lang')
            text        = lang_text(p1, tokens, player_lang) + ' ' + lang_text(p2, tokens, player_lang)

            if chat in (1, 3):
               es.cexec(loop_userid, 'echo ' + self.__removeTags(text))
            elif chat:
               es.tell(loop_userid, '#multi', text)
            if center:
               es.centertell(loop_userid, self.__removeTags(text))
            if hud:
               self._hudHint(loop_userid, self.__removeTags(text))

   def _getBombTime(self):
      return self.start_time - self.ticks / self.bps

   def _loadEvents(self):
      """Loads the .res file for the events"""
      if os.path.isfile(es.getAddonPath('cheapwirecut') + '/cheapwirecut.res'):
         es.loadevents('declare', 'addons/eventscripts/cheapwirecut/cheapwirecut.res')
      else:
         events = {'bomb_wire':{'userid':'short', 'action':'string', 'result':'string'}, 'cheapwirecut_minigame':{'userid':'short', 'action':'string', 'pull':'short', 'cut':'short'}}

         if not os.path.isfile(es.getAddonPath('cheapwirecut') + 'es_cheapwirecut_events_db.txt'):
            es.keygroupcreate('cheapwirecut_events')
            for event_name in events:
               es.keycreate('cheapwirecut_events', event_name)
               for event_var in events[event_name]:
                  es.keysetvalue('cheapwirecut_events', event_name, event_var, events[event_name][event_var])
            es.keygroupsave('cheapwirecut_events', '|cheapwirecut')
            es.keygroupdelete('cheapwirecut_events')
         es.loadevents('declare', 'addons/eventscripts/cheapwirecut/es_cheapwirecut_events_db.txt')
         es.dbgmsg(0, 'CheapWireCut: Unable to load cheapwirecut.res! Please ensure it is in the ./cheapwirecut/ directory.')

   def _hudHint(self, userid, message):
      """Sends the player a HUD hint"""
      es.usermsg('create', 'cheapwirecut_hud', 'HintText')
      es.usermsg('write', 'short', 'cheapwirecut_hud', -1)
      es.usermsg('write', 'string', 'cheapwirecut_hud', message)
      es.usermsg('send', 'cheapwirecut_hud', userid)
      es.usermsg('delete', 'cheapwirecut_hud')

   def __removeTags(self, text):
      """Removes #lightgreen, #green and #default tags from the supplied string"""
      return text.replace('#lightgreen', '').replace('#green', '').replace('#default', '')

cwc = CheapWireCutManager()


###


def getLangText():
   lang_path = es.getAddonPath(info.basename) + '/%s_languages.ini' % info.basename
   if os.path.isfile(lang_path):
      return langlib.Strings(lang_path)

   else:
      es.dbgmsg(0, '%(name)s: Unable to load %(basename)s_languages.ini! Please ensure it is in the ./%(basename)s/ directory.' % {'name':info.name, 'basename':info.basename})
      return lambda x, y, z: '%s: %s_languages.ini not found' % (info.name, info.basename)

lang_text = getLangText()


###


def load():
   """
   Ensures critical server variables are created by the config
   Calls load_events
   """
   config.execute()

   cwc._loadEvents()


def es_map_start(event_var):
   popup.clearPlayers()

   cwc._loadEvents()


def round_start(event_var):
   popup.clearPlayers(True)

   cwc.resetTicks()


def bomb_beginplant(event_var):
   cwc.miniGame(int(event_var['userid']))


def bomb_abortplant(event_var):
   cwc.bombAbortPlant()


def bomb_planted(event_var):
   cwc.closeMenu(event_var['userid'])

   cwc.bombPlanted()


def bomb_beep(event_var):
   cwc.tick()


def bomb_begindefuse(event_var):
   cwc.bombBeginDefuse(int(event_var['userid']))


def bomb_abortdefuse(event_var):
   cwc.closeMenu(int(event_var['userid']))


def bomb_defused(event_var):
   userid = int(event_var['userid'])
   cwc.closeMenu(userid)

   cwc.bombDefused(userid)


def bomb_exploded(event_var):
   popup.clearPlayers(True)

   cwc.bombExploded()


def player_hurt(event_var):
   cwc.playerHurt(int(event_var['userid']))


def player_disconnect(event_var):
   popup.removePlayer(event_var['userid'])


def unload():
   popup.clearPlayers(True)

   for cvar in config.getCvars():
      es.ServerVar(cvar).set(0)


###


class CheapPopup(object):
   class Player(object):
      menu     = ()
      callback = None
      timeout  = None

      def __init__(self, userid, parent):
         self.userid = userid
         self.parent = parent

      def send(self, duration, text, callback=None, timeout=None):
         if not self.menu:
            es.menu(0, self.userid, ' ')
            es.cexec(self.userid, 'slot10')

         self.menu     = (duration, self.userid, text)
         self.callback = callback
         self.timeout  = timeout

      def unSend(self):
         if not self.menu:
            es.cexec(self.userid, 'slot10')

         self.removeDelay()
         self.parent.removePlayer(self.userid)

      def selection(self, item):
         if item == 10 and self.menu:
            es.menu(*self.menu)

            delay = self.menu[0]
            if delay:
               gamethread.delayedname(delay, self.parent.basename + '_popup_' + str(self.userid), self._endDelay)

            self.menu = ()
            return

         self.parent.removePlayer(self.userid)

         if self.callback(self.userid, item) if self.callback else True:
            if item <> 10:
               es.cexec(self.userid, 'slot%s' % item)

      def _endDelay(self):
         self.parent.removePlayer(self.userid)
         if self.timeout:
            self.timeout(self.userid)

      def removeDelay(self):
         gamethread.cancelDelayed(self.parent.basename + '_popup_' + str(self.userid))

   """ Begin CheapPopup """
   basename = __name__

   def __init__(self):
      self.players = {}

   """ Player functions """

   def getPlayer(self, userid):
      userid = int(userid)
      if userid not in self.players:
         self.players[userid] = self.Player(userid, self)
         es.addons.registerClientCommandFilter(self._selection_hook)

      return self.players[userid]

   def removePlayer(self, userid):
      userid = int(userid)
      if userid in self.players:
         self.players[userid].removeDelay()
         del self.players[userid]

   def clearPlayers(self, unsend=False):
      if unsend:
         for userid in self.players.keys():
            self.players[userid].unSend()

      else:
         for userid in self.players:
            self.players[userid].removeDelay()

         self.players.clear()

      es.addons.unregisterClientCommandFilter(self._selection_hook)

   """ Popup functions """

   def send(self, userid, duration, text, callback=None, timeout=None):
      self.getPlayer(userid).send(duration, text, callback, timeout)

   def unsend(self, userid):
      userid = int(userid)
      if userid in self.players:
         self.getPlayer(userid).unSend()

   def _selection_hook(self, userid, args):
      if userid in self.players and args[0].lower() == 'menuselect' and len(args) > 1:
         self.getPlayer(userid).selection(int(args[1]))

      return True

popup = CheapPopup()